#ifndef _cmouse_
#define _cmouse_

#include <dos.h>

#ifndef _word_
#define _word_

 typedef unsigned short word;

#endif

 class CMouse
 {
  private:
   struct REGPACK regs;
   char Left_Pressed,Right_Pressed,Middle_Pressed;
   void GetButtons (word reg); //state of buttons
  public:
   char Left,Right,Middle; //buttons
   word X,Y; //coordinates
   CMouse ();
   char Init (); //initialization ("hardware reset")
   void Display (); //cursor on
   void Hide (); //cursor off
   void GetState (); //get position & state of buttons
   void SetPos (word x, word y); //set position
   void SetHRange (word minx, word maxx); //set horizontal range
   void SetVRange (word miny, word maxy); //set vertical range
 };//CMouse

 CMouse::CMouse ()
 {
  Left_Pressed = 0x01;
  Right_Pressed = 0x02;
  Middle_Pressed = 0x04;
 }//CMouse

 void CMouse::GetButtons (word reg)
 {
  Left = 0; Right = 0; Middle = 0;
  if ((reg && Left_Pressed) == Left_Pressed) Left = 1; //left pressed
  if ((reg && Right_Pressed) == Right_Pressed) Right = 1; //right pressed
  if ((reg && Middle_Pressed) == Middle_Pressed) Middle = 1; //middle pressed
 }//GetButtons

 char CMouse::Init ()
 {
  regs.r_ax = 0; intr (0x33,&regs);
  if (regs.r_ax != 0xFFFF) return 0; //driver is not installed
  Left = 0; Right = 0; Middle = 0; X = 0; Y = 0;
  return 1;
 }//Init

 void CMouse::Display ()
 {
  regs.r_ax = 1; intr (0x33,&regs);
 }//Display

 void CMouse::Hide ()
 {
  regs.r_ax = 2; intr (0x33,&regs);
 }//Hide

 void CMouse::GetState ()
 {
  regs.r_ax = 3; intr (0x33,&regs);
  X = regs.r_cx; Y = regs.r_dx;
  GetButtons (regs.r_bx);
 }//GetState

 void CMouse::SetPos (word x, word y)
 {
  regs.r_ax = 4; regs.r_cx = x; regs.r_dx = y; intr (0x33,&regs);
 }//SetPos

 void CMouse::SetHRange (word minx, word maxx)
 {
  regs.r_ax = 7; regs.r_cx = minx; regs.r_dx = maxx; intr (0x33,&regs);
 }//SetHRange

 void CMouse::SetVRange (word miny, word maxy)
 {
  regs.r_ax = 8; regs.r_cx = miny; regs.r_dx = maxy; intr (0x33,&regs);
 }//SetVRange

#endif